ON_PolyEdgeCurve Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_polyedgecurve.h>`

Inheritance diagram for ON_PolyEdgeCurve:

## Public Member Functions

| ON_PolyEdgeCurve ()
| ~ON_PolyEdgeCurve ()
void | DestroyRuntimeCache (bool bDelete=true)
ON_BOOL32 | IsClosed () const
ON_Curve * | DuplicateCurve () const
bool | Create (const ON_BrepTrim *trim, const ON_UUID &object_id)
bool | Create (const ON_Curve *curve, const ON_UUID &object_id)
int | SegmentCount () const
ON_PolyEdgeSegment * | SegmentCurve (int segment_index) const
ON_PolyEdgeSegment * | operator[] (int) const
ON_BOOL32 | Prepend (ON_PolyEdgeSegment *new_segment)
ON_BOOL32 | Append (ON_PolyEdgeSegment *new_segment)
ON_BOOL32 | Insert (int segment_index, ON_PolyEdgeSegment *new_segment)
const ON_BrepEdge * | EdgeAt (double t) const
const ON_BrepTrim * | TrimAt (double t) const
const ON_Brep * | BrepAt (double t) const
const ON_BrepFace * | FaceAt (double t) const
const ON_Surface * | SurfaceAt (double t) const
ON_Surface::ISO | IsoType (double t) const
double | EdgeParameter (double t) const
bool | ContainsAnyEdges () const
bool | ContainsAllEdges () const
int | FindEdge (const ON_BrepEdge *edge) const
int | FindTrim (const ON_BrepTrim *trim) const
int | FindCurve (const ON_Curve *curve) const
ON_BOOL32 | SetStartPoint (ON_3dPoint start_point)
ON_BOOL32 | SetEndPoint (ON_3dPoint end_point)
ON_BOOL32 | ChangeClosedCurveSeam (double t)
ON_BOOL32 | PrependAndMatch (ON_Curve *)
ON_BOOL32 | AppendAndMatch (ON_Curve *)
ON_BOOL32 | Remove ()
ON_BOOL32 | Remove (int index)
Public Member Functions inherited from ON_PolyCurve
| ON_PolyCurve ()
| ON_PolyCurve (int)
| ON_PolyCurve (const ON_PolyCurve &)
void | Destroy ()
virtual | ~ON_PolyCurve ()
void | EmergencyDestroy ()
ON_PolyCurve & | operator= (const ON_PolyCurve &)
unsigned int | SizeOf () const
ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const
bool | IsValid (bool bAllowGaps, ON_TextLog *text_log) const
void | Dump (ON_TextLog &) const
ON_BOOL32 | Write (ON_BinaryArchive &) const
ON_BOOL32 | Read (ON_BinaryArchive &)
int | Dimension () const
ON_BOOL32 | GetBBox (double *, double *, ON_BOOL32=false) const
bool | GetTightBoundingBox (ON_BoundingBox &tight_bbox, int bGrowBox=false, const ON_Xform *xform=0) const
ON_BOOL32 | Transform (const ON_Xform &)
bool | IsDeformable () const
bool | MakeDeformable ()
ON_BOOL32 | SwapCoordinates (int, int)
bool | EvaluatePoint (const class ON_ObjRef &objref, ON_3dPoint &P) const
ON_Interval | Domain () const
ON_BOOL32 | SetDomain (double t0, double t1)
bool | ChangeDimension (int desired_dimension)
int | SpanCount () const
ON_BOOL32 | GetSpanVector (double *) const
int | Degree () const
ON_BOOL32 | IsLinear (double=ON_ZERO_TOLERANCE) const
int | IsPolyline (ON_SimpleArray< ON_3dPoint > *pline_points=NULL, ON_SimpleArray< double > *pline_t=NULL) const
ON_BOOL32 | IsArc (const ON_Plane *=NULL, ON_Arc *=NULL, double=ON_ZERO_TOLERANCE) const
ON_BOOL32 | IsPlanar (ON_Plane *=NULL, double=ON_ZERO_TOLERANCE) const
ON_BOOL32 | IsInPlane (const ON_Plane &, double=ON_ZERO_TOLERANCE) const
ON_BOOL32 | IsPeriodic (void) const
bool | GetNextDiscontinuity (ON::continuity c, double t0, double t1, double *t, int *hint=NULL, int *dtype=NULL, double cos_angle_tolerance=ON_DEFAULT_ANGLE_TOLERANCE_COSINE, double curvature_tolerance=ON_SQRT_EPSILON) const
bool | IsContinuous (ON::continuity c, double t, int *hint=NULL, double point_tolerance=ON_ZERO_TOLERANCE, double d1_tolerance=ON_ZERO_TOLERANCE, double d2_tolerance=ON_ZERO_TOLERANCE, double cos_angle_tolerance=ON_DEFAULT_ANGLE_TOLERANCE_COSINE, double curvature_tolerance=ON_SQRT_EPSILON) const
ON_BOOL32 | Reverse ()
ON_BOOL32 | Evaluate (double, int, int, double *, int=0, int *=0) const
ON_BOOL32 | Trim (const ON_Interval &domain)
bool | Extend (const ON_Interval &domain)
ON_BOOL32 | Split (double t, ON_Curve *&left_side, ON_Curve *&right_side) const
int | GetNurbForm (ON_NurbsCurve &, double=0.0, const ON_Interval *=NULL) const
int | HasNurbForm () const
ON_BOOL32 | GetCurveParameterFromNurbFormParameter (double, double *) const
ON_BOOL32 | GetNurbFormParameterFromCurveParameter (double, double *) const
int | Count () const
ON_Curve * | operator[] (int) const
ON_Curve * | SegmentCurve (int segment_index) const
double | SegmentCurveParameter (double polycurve_parameter) const
double | PolyCurveParameter (int segment_index, double segmentcurve_parameter) const
ON_Interval | SegmentDomain (int segment_index) const
int | SegmentIndex (double polycurve_parameter) const
int | SegmentIndex (ON_Interval sub_domain, int *segment_index0, int *segment_index1) const
ON_Curve * | FirstSegmentCurve () const
ON_Curve * | LastSegmentCurve () const
int | FindNextGap (int segment_index0) const
bool | HasGapAt (int segment_index) const
ON_DEPRECATED int | HasGap () const
bool | CloseGap (int gap_index, int segments_to_modify)
int | CloseGaps ()
void | Reserve (int)
ON_BOOL32 | Prepend (ON_Curve *)
ON_BOOL32 | Append (ON_Curve *)
ON_BOOL32 | Insert (int, ON_Curve *)
ON_BOOL32 | PrependAndMatch (ON_Curve *)
ON_BOOL32 | AppendAndMatch (ON_Curve *)
ON_BOOL32 | Remove ()
ON_BOOL32 | Remove (int)
ON_Curve * | HarvestSegment (int)
bool | IsNested () const
void | RemoveNesting ()
bool | RemoveNestingEx ()
bool | HasSynchronizedSegmentDomains () const
bool | SynchronizeSegmentDomains ()
void | SetSegment (int index, ON_Curve *crv)
bool | SetParameterization (const double *t)
bool | ParameterSearch (double t, int &index, bool bEnableSnap) const
const ON_CurveArray & | SegmentCurves () const
const ON_SimpleArray< double > & | SegmentParameters () const
Public Member Functions inherited from ON_Curve
| ON_Curve ()
| ON_Curve (const ON_Curve &)
ON_Curve & | operator= (const ON_Curve &)
virtual | ~ON_Curve ()
ON::object_type | ObjectType () const
ON_BOOL32 | GetDomain (double *t0, double *t1) const
bool | SetDomain (ON_Interval domain)
virtual ON_BOOL32 | GetSpanVectorIndex (double t, int side, int *span_vector_index, ON_Interval *span_domain) const
virtual ON_BOOL32 | GetParameterTolerance (double t, double *tminus, double *tplus) const
bool | IsArcAt (double t, const ON_Plane *plane=0, ON_Arc *arc=0, double tolerance=ON_ZERO_TOLERANCE, double *t0=0, double *t1=0) const
virtual bool | IsEllipse (const ON_Plane *plane=NULL, ON_Ellipse *ellipse=NULL, double tolerance=ON_ZERO_TOLERANCE) const
bool | IsClosable (double tolerance, double min_abs_size=0.0, double min_rel_size=10.0) const
ON_3dPoint | PointAt (double t) const
ON_3dPoint | PointAtStart () const
ON_3dPoint | PointAtEnd () const
ON_3dVector | DerivativeAt (double t) const
ON_3dVector | TangentAt (double t) const
ON_3dVector | CurvatureAt (double t) const
ON_BOOL32 | FrameAt (double t, ON_Plane &plane) const
ON_BOOL32 | EvPoint (double t, ON_3dPoint &point, int side=0, int *hint=0) const
ON_BOOL32 | Ev1Der (double t, ON_3dPoint &point, ON_3dVector &first_derivative, int side=0, int *hint=0) const
ON_BOOL32 | Ev2Der (double t, ON_3dPoint &point, ON_3dVector &first_derivative, ON_3dVector &second_derivative, int side=0, int *hint=0) const
ON_BOOL32 | EvTangent (double t, ON_3dPoint &point, ON_3dVector &tangent, int side=0, int *hint=0) const
ON_BOOL32 | EvCurvature (double t, ON_3dPoint &point, ON_3dVector &tangent, ON_3dVector &kappa, int side=0, int *hint=0) const
bool | FirstSpanIsLinear (double min_length, double tolerance) const
bool | LastSpanIsLinear (double min_length, double tolerance) const
bool | FirstSpanIsLinear (double min_length, double tolerance, ON_Line *span_line) const
bool | LastSpanIsLinear (double min_length, double tolerance, ON_Line *span_line) const
ON_NurbsCurve * | NurbsCurve (ON_NurbsCurve *pNurbsCurve=NULL, double tolerance=0.0, const ON_Interval *subdomain=NULL) const
void | DestroyCurveTree ()
Public Member Functions inherited from ON_Geometry
| ON_Geometry ()
| ON_Geometry (const ON_Geometry &)
ON_Geometry & | operator= (const ON_Geometry &)
virtual | ~ON_Geometry ()
ON_BoundingBox | BoundingBox () const
ON_BOOL32 | GetBoundingBox (ON_BoundingBox &bbox, int bGrowBox=false) const
ON_BOOL32 | GetBoundingBox (ON_3dPoint &bbox_min, ON_3dPoint &bbox_max, int bGrowBox=false) const
ON_BOOL32 | Rotate (double sin_angle, double cos_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Rotate (double rotation_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Translate (const ON_3dVector &translation_vector)
ON_BOOL32 | Scale (double scale_factor)
virtual void | ClearBoundingBox ()
virtual ON_BOOL32 | HasBrepForm () const
virtual ON_Brep * | BrepForm (ON_Brep *brep=NULL) const
virtual ON_COMPONENT_INDEX | ComponentIndex () const
Public Member Functions inherited from ON_Object
bool | CopyFrom (const ON_Object *src)
| ON_Object ()
| ON_Object (const ON_Object &)
ON_Object & | operator= (const ON_Object &)
virtual | ~ON_Object ()
void | EmergencyDestroy ()
virtual void | MemoryRelocate ()
ON_BOOL32 | IsKindOf (const ON_ClassId *pClassId) const
virtual ON_UUID | ModelObjectId () const
bool | SetUserString (const wchar_t *key, const wchar_t *string_value)
int | SetUserStrings (int count, const ON_UserString *user_strings, bool bReplace)
bool | GetUserString (const wchar_t *key, ON_wString &string_value) const
int | GetUserStrings (ON_ClassArray< ON_UserString > &user_strings) const
int | GetUserStringKeys (ON_ClassArray< ON_wString > &user_string_keys) const
int | UserStringCount () const
ON_BOOL32 | AttachUserData (ON_UserData *pUserData)
ON_BOOL32 | DetachUserData (ON_UserData *pUserData)
ON_UserData * | GetUserData (const ON_UUID &userdata_uuid) const
void | PurgeUserData ()
ON_UserData * | FirstUserData () const
void | TransformUserData (const ON_Xform &xform)
void | CopyUserData (const ON_Object &source_object)
void | MoveUserData (ON_Object &source_object)

## Additional Inherited Members

Protected Member Functions inherited from ON_Curve
bool | ParameterSearch (double t, int &index, bool bEnableSnap, const ON_SimpleArray< double > &m_t, double RelTol=ON_SQRT_EPSILON) const

## Detailed Description

Definition at line 22 of file opennurbs_polyedgecurve.h.

## Constructor & Destructor Documentation

## ON_PolyEdgeCurve()

ON_PolyEdgeCurve::ON_PolyEdgeCurve | ( |  | ) |

## ~ON_PolyEdgeCurve()

ON_PolyEdgeCurve::~ON_PolyEdgeCurve | ( |  | ) |

## Member Function Documentation

## Append()

ON_BOOL32 ON_PolyEdgeCurve::Append | ( | ON_PolyEdgeSegment * | new_segment | ) |

## AppendAndMatch()

ON_BOOL32 ON_PolyEdgeCurve::AppendAndMatch | ( | ON_Curve * |  | ) |

## BrepAt()

const ON_Brep* ON_PolyEdgeCurve::BrepAt | ( | double | t | ) | const

## ChangeClosedCurveSeam()

ON_BOOL32 ON_PolyEdgeCurve::ChangeClosedCurveSeam | ( | double | t | ) |

virtual

Reimplemented from ON_PolyCurve.

## ContainsAllEdges()

bool ON_PolyEdgeCurve::ContainsAllEdges | ( |  | ) | const

## ContainsAnyEdges()

bool ON_PolyEdgeCurve::ContainsAnyEdges | ( |  | ) | const

## Create() [1/2]

bool ON_PolyEdgeCurve::Create | ( | const ON_BrepTrim * | trim,
|  | const ON_UUID & | object_id
| ) |  |

## Create() [2/2]

bool ON_PolyEdgeCurve::Create | ( | const ON_Curve * | curve,
|  | const ON_UUID & | object_id
| ) |  |

## DestroyRuntimeCache()

void ON_PolyEdgeCurve::DestroyRuntimeCache | ( | bool | bDelete = `true` | ) |

virtual

Reimplemented from ON_PolyCurve.

## DuplicateCurve()

ON_Curve* ON_PolyEdgeCurve::DuplicateCurve | ( |  | ) | const

virtual

Reimplemented from ON_PolyCurve.

## EdgeAt()

const ON_BrepEdge* ON_PolyEdgeCurve::EdgeAt | ( | double | t | ) | const

## EdgeParameter()

double ON_PolyEdgeCurve::EdgeParameter | ( | double | t | ) | const

## FaceAt()

const ON_BrepFace* ON_PolyEdgeCurve::FaceAt | ( | double | t | ) | const

## FindCurve()

int ON_PolyEdgeCurve::FindCurve | ( | const ON_Curve * | curve | ) | const

## FindEdge()

int ON_PolyEdgeCurve::FindEdge | ( | const ON_BrepEdge * | edge | ) | const

## FindTrim()

int ON_PolyEdgeCurve::FindTrim | ( | const ON_BrepTrim * | trim | ) | const

## Insert()

ON_BOOL32 ON_PolyEdgeCurve::Insert | ( | int | segment_index,
|  | ON_PolyEdgeSegment * | new_segment
| ) |  |

## IsClosed()

ON_BOOL32 ON_PolyEdgeCurve::IsClosed | ( |  | ) | const

virtual

Reimplemented from ON_PolyCurve.

## IsoType()

ON_Surface::ISO ON_PolyEdgeCurve::IsoType | ( | double | t | ) | const

## operator[]()

ON_PolyEdgeSegment* ON_PolyEdgeCurve::operator[] | ( | int |  | ) | const

## Prepend()

ON_BOOL32 ON_PolyEdgeCurve::Prepend | ( | ON_PolyEdgeSegment * | new_segment | ) |

## PrependAndMatch()

ON_BOOL32 ON_PolyEdgeCurve::PrependAndMatch | ( | ON_Curve * |  | ) |

## Remove() [1/2]

ON_BOOL32 ON_PolyEdgeCurve::Remove | ( |  | ) |

## Remove() [2/2]

ON_BOOL32 ON_PolyEdgeCurve::Remove | ( | int | index | ) |

## SegmentCount()

int ON_PolyEdgeCurve::SegmentCount | ( |  | ) | const

## SegmentCurve()

ON_PolyEdgeSegment* ON_PolyEdgeCurve::SegmentCurve | ( | int | segment_index | ) | const

## SetEndPoint()

ON_BOOL32 ON_PolyEdgeCurve::SetEndPoint | ( | ON_3dPoint | end_point | ) |

virtual

Reimplemented from ON_PolyCurve.

## SetStartPoint()

ON_BOOL32 ON_PolyEdgeCurve::SetStartPoint | ( | ON_3dPoint | start_point | ) |

virtual

Reimplemented from ON_PolyCurve.

## SurfaceAt()

const ON_Surface* ON_PolyEdgeCurve::SurfaceAt | ( | double | t | ) | const

## TrimAt()

const ON_BrepTrim* ON_PolyEdgeCurve::TrimAt | ( | double | t | ) | const

The documentation for this class was generated from the following file:

- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/surface/include/pcl/surface/3rdparty/opennurbs/opennurbs_polyedgecurve.h